"""Uses ldap to retrieve a list of brokers."""

import util, popen2, os

def queryLdap(t):
	os.environ["GLITE_SD_PLUGIN"] = "bdii"
	p = popen2.Popen3("glite-sd-query -e -t %s" % t,1)
	p.tochild.close()
	tmp = p.fromchild.readlines()
	p.fromchild.close()
	err = p.childerr.readlines()
	p.childerr.close()
	p.wait()
	return "".join(tmp)



def getBroker():
	types = ["msg.broker.rest", "msg.broker.stomp"]
	out = []
	for t in types:
		out.append(queryLdap(t))
	
	brokerlist = []
	for line in "".join(out).split("\n"):
		try:
			line = line.strip()
			if line:
				if line[:12] == "failover://(":
					b1, b2 = line[12:-1].split(",")
					brokerlist.append(b1)
					brokerlist.append(b2)
				elif line[:7] in ["stomp:/", "http://"]:
					brokerlist.append(line)	
		except:
			continue
	return util.getUrlsAsDicts(brokerlist)

if __name__ == "__main__":
	print getBroker()
